SystemOrganization addCategory: #'OB-Regex-Commands'!
SystemOrganization addCategory: #'OB-Regex-Tools'!

ORCmdRefactoring subclass: #ORCmdRegexRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Regex-Commands'!

ORCmdRegexRefactoring subclass: #ORCmdClassRegexRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Regex-Commands'!

!ORCmdClassRegexRefactoring methodsFor: 'accessing' stamp: 'lr 2/3/2008 22:33'!
label
	^ 'class regex...'! !

!ORCmdClassRegexRefactoring methodsFor: 'accessing' stamp: 'lr 2/3/2008 22:11'!
refactoringClass
	^ ORClassRegexRefactoring! !

!ORCmdRegexRefactoring methodsFor: 'accessing' stamp: 'lr 2/3/2008 21:19'!
cluster
	^ #open! !

!ORCmdRegexRefactoring methodsFor: 'accessing' stamp: 'lr 2/3/2008 21:19'!
group
	^ #regex! !

!ORCmdRegexRefactoring methodsFor: 'accessing' stamp: 'lr 2/3/2008 22:11'!
refactoring
	| find replace |
	find := self request: 'Find expression'.
	replace := self request: 'Replace with'.
	^ self refactoringClass find: find replace: replace! !

!ORCmdRegexRefactoring methodsFor: 'accessing' stamp: 'lr 2/3/2008 21:49'!
refactoringClass
	self subclassResponsibility! !

ORCmdRegexRefactoring subclass: #ORCmdSourceRegexRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Regex-Commands'!

!ORCmdSourceRegexRefactoring methodsFor: 'accessing' stamp: 'lr 2/3/2008 22:33'!
label
	^ 'source regex...'! !

!ORCmdSourceRegexRefactoring methodsFor: 'accessing' stamp: 'lr 2/3/2008 21:50'!
refactoringClass
	^ ORSourceRegexRefactoring! !

ORCommand subclass: #ORCmdRegexEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Regex-Commands'!

ORCmdRegexEnvironment subclass: #ORCmdCategoryRegexEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Regex-Commands'!

!ORCmdCategoryRegexEnvironment methodsFor: 'accessing' stamp: 'lr 1/28/2008 23:08'!
label
	^ 'category regex...'! !

!ORCmdCategoryRegexEnvironment methodsFor: 'execution' stamp: 'lr 1/28/2008 23:28'!
search: aMatcher
	| categories parent |
	categories := Set new.
	parent := self environment.
	parent categories do: [ :category |
		(aMatcher matches: category)
			ifTrue: [ categories add: category ] ].
	^ CategoryEnvironment onEnvironment: parent categories: categories! !

ORCmdRegexEnvironment subclass: #ORCmdClassRegexEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Regex-Commands'!

!ORCmdClassRegexEnvironment methodsFor: 'accessing' stamp: 'lr 1/28/2008 23:00'!
label
	^ 'class regex...'! !

!ORCmdClassRegexEnvironment methodsFor: 'execution' stamp: 'lr 1/28/2008 23:13'!
search: aMatcher
	| parent environment |
	parent := self environment.
	environment := ClassEnvironment onEnvironment: parent.
	parent classesDo: [ :class |
		aMatcher 
			matchesIn: class name
			do: [ :each | environment addClass: class; addSearchString: each ] ].
	^ environment! !

ORCmdRegexEnvironment subclass: #ORCmdProtocolRegexEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Regex-Commands'!

!ORCmdProtocolRegexEnvironment methodsFor: 'accessing' stamp: 'lr 1/28/2008 23:01'!
label
	^ 'protocol regex...'! !

!ORCmdProtocolRegexEnvironment methodsFor: 'execution' stamp: 'lr 1/28/2008 23:14'!
search: aMatcher
	| parent environment |
	parent := self environment.
	environment := SelectorEnvironment onEnvironment: parent.
	parent classesDo: [ :class |
		(parent protocolsFor: class) do: [ :protocol |
			(aMatcher matches: protocol) ifTrue: [
				(parent selectorsFor: protocol in: class) do: [ :selector |
					environment addClass: class selector: selector ] ] ] ].
	^ environment! !

!ORCmdRegexEnvironment methodsFor: 'accessing' stamp: 'lr 1/28/2008 22:47'!
cluster
	^ #'open environment'! !

!ORCmdRegexEnvironment methodsFor: 'execution' stamp: 'lr 1/28/2008 23:00'!
execute
	| expression matcher |
	expression := [ self request: 'Regular Expression' ]
		on: ORUICancellationError
		do: [ :err | ^ self ].
	matcher := [ expression asRegex ]
		on: RegexError
		do: [ :err | ^ self inform: err messageText ].
	self open: (self search: matcher)! !

!ORCmdRegexEnvironment methodsFor: 'accessing' stamp: 'lr 1/28/2008 22:25'!
group
	^ #regex! !

!ORCmdRegexEnvironment methodsFor: 'execution' stamp: 'lr 1/28/2008 22:52'!
search: aMatcher
	self subclassResponsibility! !

ORCmdRegexEnvironment subclass: #ORCmdSelectorRegexEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Regex-Commands'!

!ORCmdSelectorRegexEnvironment methodsFor: 'accessing' stamp: 'lr 1/28/2008 23:00'!
label
	^ 'selector regex...'! !

!ORCmdSelectorRegexEnvironment methodsFor: 'execution' stamp: 'lr 1/28/2008 23:16'!
search: aMatcher
	| parent environment |
	parent := self environment.
	environment := SelectorEnvironment onEnvironment: parent.
	parent classesAndSelectorsDo: [ :class :selector |
		aMatcher
			matchesIn: selector
			do: [ :each | environment addClass: class selector: selector; addSearchString: each ] ].
	^ environment! !

ORCmdRegexEnvironment subclass: #ORCmdSourceRegexEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Regex-Commands'!

!ORCmdSourceRegexEnvironment methodsFor: 'accessing' stamp: 'lr 1/28/2008 23:01'!
label
	^ 'source regex...'! !

!ORCmdSourceRegexEnvironment methodsFor: 'execution' stamp: 'lr 1/28/2008 23:16'!
search: aMatcher
	| parent environment |
	parent := self environment.
	environment := SelectorEnvironment onEnvironment: parent.
	parent classesAndSelectorsDo: [ :class :selector |
		aMatcher
			matchesIn: (class sourceCodeAt: selector)
			do: [ :each | environment addClass: class selector: selector; addSearchString: each ] ].
	^ environment! !

Refactoring subclass: #ORRegexRefactoring
	instanceVariableNames: 'find replace refactorings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Regex-Tools'!

ORRegexRefactoring subclass: #ORClassRegexRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Regex-Tools'!

!ORClassRegexRefactoring methodsFor: 'transforming' stamp: 'lr 2/3/2008 22:32'!
transform
	| replacement refactoring |
	self model allClassesDo: [ :class |
		(class isNil or: [ class isMeta ]) ifFalse: [
			replacement := self replace: class name asString.
			replacement = class name asString ifFalse: [
				refactoring := RenameClassRefactoring 
					model: self model
					rename: class
					to: replacement.
				refactoring preconditions check
					ifTrue: [ refactoring transform ] ] ] ]! !

!ORRegexRefactoring class methodsFor: 'instance-creation' stamp: 'lr 2/3/2008 21:30'!
find: aFindString replace: aReplaceString
	"Answer a refactoring that searches for the regular-expression aFindString. Depending on the subclass implementation it replaces matches with aReplaceString, where \# references a matched group."
	
	^ self new find: aFindString replace: aReplaceString! !

!ORRegexRefactoring methodsFor: 'initialization' stamp: 'lr 2/3/2008 22:00'!
find: aFindString replace: aReplaceString
	find := aFindString asRegex.
	replace := aReplaceString readStream! !

!ORRegexRefactoring methodsFor: 'preconditions' stamp: 'lr 2/3/2008 22:02'!
preconditions
	^ RBCondition empty! !

!ORRegexRefactoring methodsFor: 'private' stamp: 'lr 1/7/2008 10:51'!
replace: aString
	^ find copy: aString translatingMatchesUsing: [ :match |
		String streamContents: [ :stream |
			[ replace atEnd ] whileFalse: [
				stream nextPutAll: (replace upTo: $\).
				replace atEnd ifFalse: [
					replace peek isDigit
						ifFalse: [ stream nextPut: replace next ]
						ifTrue: [ stream nextPutAll: (find subexpression: replace next asInteger - $0 asInteger + 1) ] ] ].
			replace reset ] ]! !

ORRegexRefactoring subclass: #ORSourceRegexRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Regex-Tools'!

!ORSourceRegexRefactoring methodsFor: 'transforming' stamp: 'lr 2/3/2008 22:09'!
transform
	| original replacement parseTree protocols |
	self model allClassesDo: [ :class |
		class selectors do: [ :selector |
			original := class sourceCodeFor: selector.
			replacement := self replace: original.
			replacement = original ifFalse: [
				parseTree := [ RBParser parseMethod: replacement ]
					on: Error
					do: [ :err | nil ].
				parseTree isNil ifFalse: [
					protocols := class protocolsFor: selector.
					class
						removeMethod: selector;
						compile: replacement classified: protocols ] ] ] ]! !

!OBCodeBrowser methodsFor: '*ob-regex-commands' stamp: 'lr 2/3/2008 21:20'!
cmdRegexEnvironment
	^ ORCmdRegexEnvironment allSubclasses! !

!OBCodeBrowser methodsFor: '*ob-regex-commands' stamp: 'lr 2/3/2008 21:20'!
cmdRegexRefactoring
	^ ORCmdRegexRefactoring allSubclasses! !
